﻿using System.Collections.Generic;
using System.Linq;
using System.Web.Http;
using Breeze.ContextProvider;
using Breeze.ContextProvider.EF6;
using Breeze.WebApi2;
using DataAccess;
using DomainTypes;
using Newtonsoft.Json.Linq;

namespace April2014SampleWebForms
{
  [BreezeController]
  public class BreezeController : ApiController
  {
    private readonly EFContextProvider<FunStuffTrackerContext> _contextProvider =
      new EFContextProvider<FunStuffTrackerContext>();

    [HttpGet]
    public string Metadata()
    {
      return _contextProvider.Metadata();
    }

    [HttpGet]
    public IQueryable<FunStuffComment> Comments(int userId = 0)
    {
         return _contextProvider.Context.Comments.Where(c => c.UserId == userId);

#if false //processor is not necessary since code is unreachable, but there to be clear
      //temporary for in-memory data
      switch (userId)
      {
        case 1: //temporary for in-memory data
      return new List<FunStuffComment>{
        new FunStuffComment{FunStuffName = "Bike Ride",Comment = "Can't wait for spring!",FunStuffId = 1,UserId = 1},
        new FunStuffComment{FunStuffName = "Play in Snow",Comment = "Will we ever get snow?",FunStuffId = 2,UserId = 1},
        new FunStuffComment{FunStuffName = "Ski",Comment = "Also depends on that snow",FunStuffId = 3,UserId = 1}
      }.AsQueryable();

        case 2:
          return new List<FunStuffComment>
          {
            new FunStuffComment
            {
              FunStuffName = "Watch Animal Planet",
              Comment = "Especially when they run across the screen",
              FunStuffId = 1,
              UserId = 2
            },
            new FunStuffComment
            {
              FunStuffName = "Play in Snow",
              Comment = "Even better with my mommy",
              FunStuffId = 2,
              UserId = 2
            }
          }.AsQueryable();
        default:
          return new List<FunStuffComment>().AsQueryable();
      }
#endif
    }

    [HttpPost]
    public SaveResult SaveChanges(JObject saveBundle)
    {
      return _contextProvider.SaveChanges(saveBundle);
    }
  }
}