﻿using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using DataAccess;
using DomainTypes;
namespace April2014SampleWebForms
{
    public class DataRepository:IDisposable
    {
        public User GetUserById(int id) {
            using (var ctx=new FunStuffTrackerContext())
            {
                return ctx.Users.Find(id);
            }
        
        }

        public List<FunStuff> GetFunStuffList()
        {
            using (var ctx = new FunStuffTrackerContext())
            {
                return ctx.FunStuffs.OrderBy(f=>f.Description).AsNoTracking().ToList();
            }
        }


        public void UpdateFunStuffForUser(IList<int> selectedItemsListFromChecks, int userId)
        {
            using (var ctx = new FunStuffTrackerContext())
            {
                var user = ctx.Users.Find(userId);
                user.PopulateFunStuffList(selectedItemsListFromChecks);
                user.ConcantenateFunStuff();
                ctx.SaveChanges();
            }
        }


        public List<RefList> GetUserRefList()
        {
            using (var ctx = new FunStuffTrackerContext())
            {
                return ctx.Users.OrderBy(u => u.LastName).Select(u => new RefList { Name = u.FirstName + " " + u.LastName, Id = u.Id }).ToList();
            }

        }

        public class RefList
        {
            public int Id { get; set; }
            public string Name { get; set; }
        }

        public void Dispose()
        {}
    }
}