﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.UI;
using System.Web.UI.WebControls;
using DomainTypes;

namespace April2014SampleWebForms
{
    public partial class FunStuffForm : Page
    {
        private DataRepository repo;

        protected void Page_Load(object sender, EventArgs e)
        {
            repo = new DataRepository();
            if (!IsPostBack)
            {
                chkListStuff.DataSource = repo.GetFunStuffList();
                chkListStuff.DataValueField = "Id";
                chkListStuff.DataTextField = "Description";
                chkListStuff.DataBind();
              

                lstUsers.DataSource = repo.GetUserRefList();
                lstUsers.DataValueField = "Id";
                lstUsers.DataTextField = "Name";
                lstUsers.DataBind();
                GetUser();
            }
          //  UpdateChecksMarkup();
        }

        private void GetUser()
        {
            var user = repo.GetUserById(int.Parse(lstUsers.SelectedValue));
            hiddenId.Value = user.Id.ToString();
            SelectChecksFromFunStuffList(user.GetFunStuffList());
        }

        //private void UpdateChecksMarkup()
        //{
        //    foreach (ListItem item in chkListStuff.Items)
        //    {
        //        item.Attributes.Add("data-label", item.Text);
        //    }
        //}

        protected void btnSave_Click(object sender, EventArgs e)
        {
             int id;
            //parse will only fail if someone mucks with the html at runtime, real app will protect, handle issues, etc.
            if (int.TryParse(hiddenId.Value, out id))
            {
                repo.UpdateFunStuffForUser(SelectedItemsListFromChecks(), id);
            }
        }

        private List<int> SelectedItemsListFromChecks()
        {
            return chkListStuff.Items.OfType<ListItem>()
                .Where(i => i.Selected)
                .Select(item => int.Parse(item.Value)).ToList();
        }

        private void SelectChecksFromFunStuffList(IEnumerable<int> stuffList)
        {
            chkListStuff.ClearSelection();

            foreach (int item in stuffList)
            {
                ListItem chkItem = chkListStuff.Items.FindByValue(item.ToString());
                if (chkItem != null) chkItem.Selected = true;
            }
        }

        protected void lstUsers_SelectedIndexChanged(object sender, EventArgs e)
        {
            GetUser();
        }
    }
}