﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;


namespace DomainTypes
{
    public class User
    {
        private List<int> _funStuffList;
        public int Id { get; set; }
        public string FirstName { get; set; }
        public string LastName { get; set; }
        [NotMapped]
        public string FullName {
            get { return FirstName.Trim() + " " + LastName; }
        }
      
        public List<int> GetFunStuffList()
        {
         if (_funStuffList != null) return _funStuffList;
                var list = FunStuffConcatenated.Split(new[] {'|'});
                _funStuffList=new List<int>();
                foreach (string s in list)
                {
                    _funStuffList.Add(int.Parse(s));
                }
                return _funStuffList;
      }
        
        public String FunStuffConcatenated { get; private set; }

        public void ConcantenateFunStuff()
        {
            FunStuffConcatenated = String.Join("|", _funStuffList);
        }

        public void PopulateFunStuffList(IList<int> intList)
        { _funStuffList=new List<int>();
           if(intList!=null)
            _funStuffList.AddRange(intList);
            
        }
          
    }

    

    public class FunStuff
    {
        public int Id { get; set; }
        public string Description { get; set; }
    }

}
