﻿using System.Collections.Generic;
using System.Data.Entity;
using DomainTypes;

namespace DataAccess
{
    public class FunStuffTrackerContext: DbContext  
    {
        public DbSet<User> Users { get; set; }
        public DbSet<FunStuff> FunStuffs { get; set; }
    }

    public class FunStuffDbInit : DropCreateDatabaseIfModelChanges<FunStuffTrackerContext>
    {
        protected override void Seed(FunStuffTrackerContext context)
        {
            var stuffList = new List<FunStuff>
            {
                new FunStuff {Description = "Bike Ride"},
                new FunStuff {Description = "Ski"},
                new FunStuff {Description = "Play in Snow"},
                new FunStuff {Description = "Watch Doctor Who"},
                new FunStuff {Description = "Watch Animal Planet"},
                new FunStuff {Description = "Get Stuck in Airports"},
                new FunStuff {Description = "Dental Appt"},
                new FunStuff {Description = "Sunday Night Football"}
            };
            var user = new User {FirstName = "Julie", LastName = "Lerman"};
            user.PopulateFunStuffList(new []{
                1,
                2,
                3
            });
            var user2 = new User { FirstName = "Samspon", LastName = "Lerman" };
            user2.PopulateFunStuffList(new[]{
                4,
                5,
                6
            });
            var users = new List<User> { user, user2 };
            users.ForEach(u => u.ConcantenateFunStuff());
            context.Users.AddRange(users);
            context.FunStuffs.AddRange(stuffList);
            base.Seed(context);
        }
    }
}
